// WSUIO48_96TestXPDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WSUIO48_96TestXP.h"
#include "WSUIO48_96Help.h"
#include "WSUIO48_96TestXPDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Number of I/O points in each device supported by the driver.
#define	WIO_48_IO_POINTS	48
#define WIO_96_IO_POINTS	96

// Define a windows message for us to inform the dialog to
// display the points that had an interrupt.
#define WM_WSUIO_SHOW_INTERRUPTS	(WM_USER + 100)

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWSUIO48_96TestXPDlg dialog

CWSUIO48_96TestXPDlg::CWSUIO48_96TestXPDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWSUIO48_96TestXPDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWSUIO48_96TestXPDlg)
	m_nBitNumber = 1;
	m_nBitValue = FALSE;
	m_strBits24_01 = _T("000000000000000000000000");
	m_strBits48_25 = _T("000000000000000000000000");
	m_strBits72_49 = _T("000000000000000000000000");
	m_strBits96_73 = _T("000000000000000000000000");
	m_nPortNumber = 1;
	m_byPortValue = 0;
	m_nPortNumber2 = 1;
	m_strDwPortValue2 = _T("00000000");
	m_strDwlPortValue3 = _T("000000000000");
	m_strEnable24_01 = _T("000000000000000000000000");
	m_strEnable48_25 = _T("000000000000000000000000");
	m_strMask24_01 = _T("000000000000000000000000");
	m_strMask48_25 = _T("000000000000000000000000");
	m_strMask72_49 = _T("000000000000000000000000");
	m_strMask96_73 = _T("000000000000000000000000");
	m_strPolarity24_01 = _T("000000000000000000000000");
	m_strPolarity48_25 = _T("000000000000000000000000");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_ICON1);

	m_hDeviceThread = INVALID_HANDLE_VALUE;
	m_dwInterruptsPermitted = 0;
	m_nUpdateTimer = 0;

	m_ThreadData.hWIOHandle = INVALID_HANDLE_VALUE;
	m_ThreadData.hExitThread = INVALID_HANDLE_VALUE;
	m_ThreadData.hThreadExited = INVALID_HANDLE_VALUE;
	m_ThreadData.dwNumIOPoints = 0;
	m_ThreadData.fInterruptsSet = FALSE;
	m_ThreadData.fExitThread = FALSE;
	m_ThreadData.hwndDialog = NULL;

	for (int nDevice = 0; nDevice < MAX_DEVICES; ++nDevice)
	{
		for (int nPort = 0; nPort < MAX_IO_PORTS; ++nPort)
		{
			m_byPortImage[nDevice][nPort] = 0;
		}

		for (int nPort = 0; nPort < MAX_INT_PORTS; ++nPort)
		{
			m_byIntMask[nDevice][nPort] = 0;
			m_ThreadData.byIntImage[nDevice][nPort] = 0;
		}
	}
}

// ****************************************************************************
//
//	EnableDialogControls
//
//	Parameters:
//
//		None
//
//	Remarks:	Enables controls on the dialog.
//
//	Returns:	None
//
void CWSUIO48_96TestXPDlg::EnableDialogControls()
{
	m_CloseDeviceBtnCtrl.EnableWindow(TRUE);
	m_BitNumberEditCtrl.EnableWindow(TRUE);
	m_BitValueEditCtrl.EnableWindow(TRUE);
	m_ReadBitBtnCtrl.EnableWindow(TRUE);
	m_WriteBitBtnCtrl.EnableWindow(TRUE);
	m_SetBitBtnCtrl.EnableWindow(TRUE);
	m_ClrBitBtnCtrl.EnableWindow(TRUE);
	m_PortNumberEditCtrl.EnableWindow(TRUE);
	m_PortValueEditCtrl.EnableWindow(TRUE);
	m_ReadPortBtnCtrl.EnableWindow(TRUE);
	m_WritePortBtnCtrl.EnableWindow(TRUE);
	m_PortNumber2EditCtrl.EnableWindow(TRUE);
	m_PortValue2EditCtrl.EnableWindow(TRUE);
	m_ReadPort2BtnCtrl.EnableWindow(TRUE);
	m_PortValue3EditCtrl.EnableWindow(TRUE);
	m_ReadPort3BtnCtrl.EnableWindow(TRUE);
	m_Bits24_01EditCtrl.EnableWindow(TRUE);
	m_Bits48_25EditCtrl.EnableWindow(TRUE);
	m_Bits72_49EditCtrl.EnableWindow(TRUE);
	m_Bits96_73EditCtrl.EnableWindow(TRUE);

	m_Mask24_01EditCtrl.EnableWindow(TRUE);
	m_Mask48_25EditCtrl.EnableWindow(TRUE);
	if (WIO_96_IO_POINTS == m_ThreadData.dwNumIOPoints)
	{
		m_Mask72_49EditCtrl.EnableWindow(TRUE);
		m_Mask96_73EditCtrl.EnableWindow(TRUE);
	}
	m_SetMaskBtnCtrl.EnableWindow(TRUE);
	m_GetMaskBtnCtrl.EnableWindow(TRUE);
	m_ClearMaskBtnCtrl.EnableWindow(TRUE);

	if (m_dwInterruptsPermitted)
	{
		m_Enable24_01EditCtrl.EnableWindow(TRUE);
		m_Polarity24_01EditCtrl.EnableWindow(TRUE);
		if (WIO_96_IO_POINTS == m_ThreadData.dwNumIOPoints)
		{
			m_Enable48_25EditCtrl.EnableWindow(TRUE);
			m_Polarity48_25EditCtrl.EnableWindow(TRUE);
		}
		m_SetInterruptsBtnCtrl.EnableWindow(TRUE);
		m_ClearInterruptsBtnCtrl.EnableWindow(TRUE);
	}
}

// ****************************************************************************
//
//	DisableDialogControls
//
//	Parameters:
//
//		None
//
//	Remarks:	Disables controls on the dialog.
//
//	Returns:	None
//
void CWSUIO48_96TestXPDlg::DisableDialogControls()
{
	m_CloseDeviceBtnCtrl.EnableWindow(FALSE);
	m_BitNumberEditCtrl.EnableWindow(FALSE);
	m_BitValueEditCtrl.EnableWindow(FALSE);
	m_ReadBitBtnCtrl.EnableWindow(FALSE);
	m_WriteBitBtnCtrl.EnableWindow(FALSE);
	m_SetBitBtnCtrl.EnableWindow(FALSE);
	m_ClrBitBtnCtrl.EnableWindow(FALSE);
	m_PortNumberEditCtrl.EnableWindow(FALSE);
	m_PortValueEditCtrl.EnableWindow(FALSE);
	m_ReadPortBtnCtrl.EnableWindow(FALSE);
	m_WritePortBtnCtrl.EnableWindow(FALSE);
	m_PortNumber2EditCtrl.EnableWindow(FALSE);
	m_PortValue2EditCtrl.EnableWindow(FALSE);
	m_ReadPort2BtnCtrl.EnableWindow(FALSE);
	m_PortValue3EditCtrl.EnableWindow(FALSE);
	m_ReadPort3BtnCtrl.EnableWindow(FALSE);
	m_Bits24_01EditCtrl.EnableWindow(FALSE);
	m_Bits48_25EditCtrl.EnableWindow(FALSE);
	m_Bits72_49EditCtrl.EnableWindow(FALSE);
	m_Bits96_73EditCtrl.EnableWindow(FALSE);
	m_Mask24_01EditCtrl.EnableWindow(FALSE);
	m_Mask48_25EditCtrl.EnableWindow(FALSE);
	m_Mask72_49EditCtrl.EnableWindow(FALSE);
	m_Mask96_73EditCtrl.EnableWindow(FALSE);
	m_SetMaskBtnCtrl.EnableWindow(FALSE);
	m_GetMaskBtnCtrl.EnableWindow(FALSE);
	m_ClearMaskBtnCtrl.EnableWindow(FALSE);
	m_Enable24_01EditCtrl.EnableWindow(FALSE);
	m_Polarity24_01EditCtrl.EnableWindow(FALSE);
	m_Enable48_25EditCtrl.EnableWindow(FALSE);
	m_Polarity48_25EditCtrl.EnableWindow(FALSE);
	m_SetInterruptsBtnCtrl.EnableWindow(FALSE);
	m_ClearInterruptsBtnCtrl.EnableWindow(FALSE);
}

// ****************************************************************************
//
//	UpdateBitImageValue
//
//	Parameters:
//
//		DWORD		dwBitNumber
//					[IN] Bit number to update in the image.
//
//		BYTE		byBitValue
//					[IN] Update value.
//
//	Remarks:	Updates the internal Device I/O Value held in this class.
//
//	Returns:	None
//
void CWSUIO48_96TestXPDlg::UpdateBitImageValue(DWORD dwBitNumber,
											   BYTE byBitValue)
{
	int		nDevice;
	BYTE	byBitMask;
	BYTE	byPortValue;

	// Adjust bit number to be zero based.
	--dwBitNumber;

	// Calculate a bit mask for the specified bit.
	byBitMask = (1 << (dwBitNumber % 8));

	// If controlling more than 48 points, determine the device
	// this point lies on.
	nDevice = (dwBitNumber / MAX_IO_POINTS);

	// Get current image value.
	byPortValue = m_byPortImage[nDevice][dwBitNumber / 8];

	if (byBitValue)
	{
		// Set the bit.
		byPortValue |= byBitMask;
	}
	else
	{
		// Clear the bit.
		byPortValue &= ~byBitMask;
	}

	// Store the value into the image.
	m_byPortImage[nDevice][dwBitNumber / 8] = byPortValue;

	// Save in our local value.
	m_nBitValue = static_cast<int>(byBitValue);

	// Update the dialog.
	UpdateIODisplay();
}

// ****************************************************************************
//
//	UpdateByteImageValue
//
//	Parameters:
//
//		DWORD		dwPortNumber
//					[IN] Port number to update in the image.
//
//		BYTE		byPortValue
//					[IN] Update value.
//
//	Remarks:	Updates the internal Device I/O Value held in this class.
//
//	Returns:	None
//
void CWSUIO48_96TestXPDlg::UpdateByteImageValue(DWORD dwPortNumber,
												BYTE byPortValue)
{
	int		nDevice;

	// Adjust port number to be zero based.
	--dwPortNumber;

	// Determine the device this port lies on.
	nDevice = (dwPortNumber / MAX_IO_PORTS);

	// Store the value into the image.
	m_byPortImage[nDevice][dwPortNumber] = byPortValue;

	// Save in our local value.
	m_byPortValue = byPortValue;

	// Update the dialog.
	UpdateIODisplay();
}

// ****************************************************************************
//
//	UpdateIODisplay
//
//	Parameters:
//
//		None
//
//	Remarks:	Updates the Device I/O Values from the port images
//				held in this class.
//
//	Returns:	None
//
void CWSUIO48_96TestXPDlg::UpdateIODisplay()
{
	TCHAR		szBinaryValue[10];

	m_strBits24_01.Empty();
	m_strBits24_01 += ConvertToBinary(m_byPortImage[0][2], szBinaryValue);
	m_strBits24_01 += ConvertToBinary(m_byPortImage[0][1], szBinaryValue);
	m_strBits24_01 += ConvertToBinary(m_byPortImage[0][0], szBinaryValue);

	m_strBits48_25.Empty();
	m_strBits48_25 += ConvertToBinary(m_byPortImage[0][5], szBinaryValue);
	m_strBits48_25 += ConvertToBinary(m_byPortImage[0][4], szBinaryValue);
	m_strBits48_25 += ConvertToBinary(m_byPortImage[0][3], szBinaryValue);

	if (WIO_96_IO_POINTS == m_ThreadData.dwNumIOPoints)
	{
		m_strBits72_49.Empty();
		m_strBits72_49 += ConvertToBinary(m_byPortImage[1][2], szBinaryValue);
		m_strBits72_49 += ConvertToBinary(m_byPortImage[1][1], szBinaryValue);
		m_strBits72_49 += ConvertToBinary(m_byPortImage[1][0], szBinaryValue);

		m_strBits96_73.Empty();
		m_strBits96_73 += ConvertToBinary(m_byPortImage[1][5], szBinaryValue);
		m_strBits96_73 += ConvertToBinary(m_byPortImage[1][4], szBinaryValue);
		m_strBits96_73 += ConvertToBinary(m_byPortImage[1][3], szBinaryValue);
	}

	// Update the dialog with the new data.
	UpdateData(FALSE);
}

// ****************************************************************************
//
//	ConvertFromBinary
//
//	Parameters:
//
//		LPCTSTR		pszAnsiBinary
//					[IN] Pointer to a NULL terminated string containing the
//					binary value.  The bit order of the string is the high
//					bit in the first byte of the string and the low bit in
//					the last byte of the string.
//
//	Remarks:	Converts a string containing a binary value into
//				its BYTE equivalent.
//
//	Returns:	BYTE value of supplied binary string.
//
const BYTE CWSUIO48_96TestXPDlg::ConvertFromBinary(LPCTSTR pszAnsiBinary)
{
	BYTE	byValue = 0;
	int		nLength = static_cast<int>(_tcslen(pszAnsiBinary));
	int		nShiftBit = 0;

	// Make sure the passed string is 8 bytes in length.
	// One byte per bit in the byte.
	ASSERT(8 == nLength);

	// TCHAR.H version of strlen.
	for (int nIndex = nLength - 1; nIndex >= 0; --nIndex)
	{
		if (_T('1') == pszAnsiBinary[nIndex])
		{
			byValue |= (1 << nShiftBit);
		}

		++nShiftBit;
	}

	return byValue;
}

// ****************************************************************************
//
//	ConvertToBinary
//
//	Parameters:
//
//		BYTE		byValue
//					[IN] Value to convert.
//
//		LPCTSTR		pszAnsiBinary
//					[IN/OUT] Pointer to a TCHAR array to receive the
//					NULL terminated string containing the binary value.
//					The bit order of the string is the high bit in the
//					first byte of the string and the low bit in the last
//					byte of the string.
//
//	Remarks:	Converts a BYTE into its binary string equivalent.
//
//	Returns:	Pointer to supplied buffer containing binary string.
//
const PTCHAR CWSUIO48_96TestXPDlg::ConvertToBinary(BYTE byValue,
												   PTCHAR pszAnsiBinary)
{
	PTCHAR	pszAnsiBinaryTable[] = {
		_T("0000"), _T("0001"), _T("0010"), _T("0011"),
		_T("0100"), _T("0101"), _T("0110"), _T("0111"),
		_T("1000"), _T("1001"), _T("1010"), _T("1011"),
		_T("1100"), _T("1101"), _T("1110"), _T("1111")
	};

	// TCHAR.H version of sprintf()
	_stprintf(pszAnsiBinary, _T("%s%s"),
		pszAnsiBinaryTable[byValue >> 4],
		pszAnsiBinaryTable[byValue & 0x0F]);

	return pszAnsiBinary;
}

// ****************************************************************************
//
//	ConvertToHex
//
//	Parameters:
//
//		DWORD		dwValue
//					[IN] Value to convert.
//
//		LPCTSTR		pszAnsiHex
//					[IN/OUT] Pointer to a TCHAR array to receive the
//					NULL terminated string containing the binary value.
//					The bit order of the string is the high bit in the
//					first byte of the string and the low bit in the last
//					byte of the string.
//
//	Remarks:	Converts a DWORD into its hex string equivalent.
//
//	Returns:	Pointer to supplied buffer containing hex string.
//
const PTCHAR CWSUIO48_96TestXPDlg::ConvertToHex(DWORD dwValue,
												   PTCHAR pszAnsiHex)
{
	PTCHAR	pszAnsiHexTable[] = {
		_T("0"), _T("1"), _T("2"), _T("3"),
		_T("4"), _T("5"), _T("6"), _T("7"),
		_T("8"), _T("9"), _T("A"), _T("B"),
		_T("C"), _T("D"), _T("E"), _T("F")
	};

	// TCHAR.H version of sprintf()
	_stprintf(pszAnsiHex, _T("%s%s%s%s%s%s%s%s"),
		pszAnsiHexTable[(dwValue >> 28) & 0x0F],
		pszAnsiHexTable[(dwValue >> 24) & 0x0F],
		pszAnsiHexTable[(dwValue >> 20) & 0x0F],
		pszAnsiHexTable[(dwValue >> 16) & 0x0F],
		pszAnsiHexTable[(dwValue >> 12) & 0x0F],
		pszAnsiHexTable[(dwValue >> 8) & 0x0F],
		pszAnsiHexTable[(dwValue >> 4) & 0x0F],
		pszAnsiHexTable[dwValue & 0x0F]);

	return pszAnsiHex;
}

// ****************************************************************************
//
//	ConvertToHex2
//
//	Parameters:
//
//		DWORDLONG	dwlValue
//					[IN] Value to convert.
//
//		LPCTSTR		pszAnsiHex
//					[IN/OUT] Pointer to a TCHAR array to receive the
//					NULL terminated string containing the binary value.
//					The bit order of the string is the high bit in the
//					first byte of the string and the low bit in the last
//					byte of the string.
//
//	Remarks:	Converts a DWORDLONG into its hex string equivalent.
//
//	Returns:	Pointer to supplied buffer containing hex string.
//
const PTCHAR CWSUIO48_96TestXPDlg::ConvertToHex2(DWORDLONG dwlValue,
												   PTCHAR pszAnsiHex)
{
	PTCHAR	pszAnsiHexTable[] = {
		_T("0"), _T("1"), _T("2"), _T("3"),
		_T("4"), _T("5"), _T("6"), _T("7"),
		_T("8"), _T("9"), _T("A"), _T("B"),
		_T("C"), _T("D"), _T("E"), _T("F")
	};

	// TCHAR.H version of sprintf()
	_stprintf(pszAnsiHex, _T("%s%s%s%s%s%s%s%s%s%s%s%s"),
		pszAnsiHexTable[(dwlValue >> 44) & 0x0F],
		pszAnsiHexTable[(dwlValue >> 40) & 0x0F],
		pszAnsiHexTable[(dwlValue >> 36) & 0x0F],
		pszAnsiHexTable[(dwlValue >> 32) & 0x0F],
		pszAnsiHexTable[(dwlValue >> 28) & 0x0F],
		pszAnsiHexTable[(dwlValue >> 24) & 0x0F],
		pszAnsiHexTable[(dwlValue >> 20) & 0x0F],
		pszAnsiHexTable[(dwlValue >> 16) & 0x0F],
		pszAnsiHexTable[(dwlValue >> 12) & 0x0F],
		pszAnsiHexTable[(dwlValue >> 8) & 0x0F],
		pszAnsiHexTable[(dwlValue >> 4) & 0x0F],
		pszAnsiHexTable[dwlValue & 0x0F]);

	return pszAnsiHex;
}

// ****************************************************************************
//
//	DeviceThread
//
//	Parameters:
//
//		PVOID		pContext
//					[IN] Pointer to a THREAD_DATA structure.
//
//	Remarks:	Thread to wait for interrupt events from the driver.
//
//	Returns:	0
//
/*static*/
DWORD WINAPI CWSUIO48_96TestXPDlg::DeviceThread(PVOID pContext)
{
	int			nNumIOPoints;
	int			nNumIntPorts;
	int			nNumDevices;
	BYTE		byIntMask[MAX_DEVICES * MAX_INT_PORTS];
	PBYTE		pbyIntMask;
	DWORD		dwActualOut;
	DWORD		dwWait;
	OVERLAPPED	overlapped;
	HANDLE		hInterruptEvent;
	BOOL		fRetCode;

	PTHREAD_DATA	pThreadData =
		reinterpret_cast<PTHREAD_DATA>(pContext);

	nNumIOPoints = (int) pThreadData->dwNumIOPoints;
	nNumDevices = (int) (nNumIOPoints / MAX_IO_POINTS);
	nNumIntPorts = nNumDevices * MAX_INT_PORTS;

	// Create an event for the overlapped IO.
	hInterruptEvent = CreateEvent(NULL, TRUE, FALSE, NULL);

	// Continue with thread until told to exit.
	while (FALSE == pThreadData->fExitThread)
	{
		// The only reason this code is here is because the
		// test application allows for the use of the driver
		// without interrupts configured.  If interrupts
		// were preconfigured prior to the execution of this
		// thread, we could simply issue the DeviceIoControl
		// and then call WaitForMultipleObjects to block
		// until the thread is signaled to shutdown or an
		// interrupt occurred in the driver.
		if (FALSE == pThreadData->fInterruptsSet)
		{
			// There are no interrupts configured.
			Sleep(0);
			continue;
		}

		// Initialize OVERLAPPED structure members.
		overlapped.Offset = 0;
		overlapped.hEvent = hInterruptEvent;

		// Inform driver to wait for interrupt.
		fRetCode = DeviceIoControl(	pThreadData->hWIOHandle,
									IOCTL_WIO_WAIT_ON_INT,
									NULL,
									0,
									byIntMask,
									nNumIntPorts,
									&dwActualOut,
									&overlapped);
		if (	(FALSE == fRetCode)
			&&	(ERROR_IO_PENDING == GetLastError()))
		{
			// Call is pending until an interrupt occurs.

			// Wait for either the interrupt from the driver
			// or a signal from the application that the
			// thread should be shutdown.
			HANDLE	hEvents[] = 
				{ pThreadData->hExitThread, overlapped.hEvent };

			dwWait = WaitForMultipleObjects(2, hEvents, FALSE, INFINITE);
			if (WAIT_OBJECT_0 == dwWait)
			{
				// Thread has been signaled to exit.

				// Cancel the pending IOCTL_WIO_WAIT_ON_INT in the driver.
				CancelIo(pThreadData->hWIOHandle);
			}
			else
			{
				// An interrupt has been issued.
				fRetCode = GetOverlappedResult(	pThreadData->hWIOHandle,
												&overlapped,
												&dwActualOut,
												TRUE);
				if (TRUE == fRetCode)
				{
					// Go through the returned data to determine which ports
					// have an interrupt.
					pbyIntMask = &byIntMask[0];

					EnterCriticalSection(&(pThreadData->hThreadCS));

					for (int nDevice = 0; nDevice < nNumDevices; ++nDevice)
					{
						for (int nPort = 0; nPort < MAX_INT_PORTS; ++nPort)
						{
							if (*pbyIntMask)
							{
								pThreadData->byIntImage[nDevice][nPort] =
									*pbyIntMask;
							}
							else
							{
								pThreadData->byIntImage[nDevice][nPort] = 0;
							}

							// Proceed to next byte.
							++pbyIntMask;
						}
					}

					LeaveCriticalSection(&(pThreadData->hThreadCS));

					// Send a message to the dialog to display the points
					// that had an interrupt.
					::SendMessage(pThreadData->hwndDialog,
						WM_WSUIO_SHOW_INTERRUPTS, 0, 0);
				}
			}
		}

	}

	// Close event handle.
	CloseHandle(hInterruptEvent);

	// Signal thread is exiting.
	SetEvent(pThreadData->hThreadExited);

	return 0;
}

void CWSUIO48_96TestXPDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWSUIO48_96TestXPDlg)
	DDX_Control(pDX, IDC_SET_MASK, m_SetMaskBtnCtrl);
	DDX_Control(pDX, IDC_SET_INTERRUPTS, m_SetInterruptsBtnCtrl);
	DDX_Control(pDX, IDC_POLARITY_48_25, m_Polarity48_25EditCtrl);
	DDX_Control(pDX, IDC_POLARITY_24_01, m_Polarity24_01EditCtrl);
	DDX_Control(pDX, IDC_MASK_96_73, m_Mask96_73EditCtrl);
	DDX_Control(pDX, IDC_MASK_72_49, m_Mask72_49EditCtrl);
	DDX_Control(pDX, IDC_MASK_48_25, m_Mask48_25EditCtrl);
	DDX_Control(pDX, IDC_MASK_24_01, m_Mask24_01EditCtrl);
	DDX_Control(pDX, IDC_GET_MASK, m_GetMaskBtnCtrl);
	DDX_Control(pDX, IDC_ENABLE_48_25, m_Enable48_25EditCtrl);
	DDX_Control(pDX, IDC_ENABLE_24_01, m_Enable24_01EditCtrl);
	DDX_Control(pDX, IDC_CLEAR_MASK, m_ClearMaskBtnCtrl);
	DDX_Control(pDX, IDC_CLEAR_INTERRUPTS, m_ClearInterruptsBtnCtrl);
	DDX_Control(pDX, IDC_BITS_96_73, m_Bits96_73EditCtrl);
	DDX_Control(pDX, IDC_BITS_72_49, m_Bits72_49EditCtrl);
	DDX_Control(pDX, IDC_BITS_48_25, m_Bits48_25EditCtrl);
	DDX_Control(pDX, IDC_BITS_24_01, m_Bits24_01EditCtrl);
	DDX_Control(pDX, IDC_WRITE_PORT, m_WritePortBtnCtrl);
	DDX_Control(pDX, IDC_READ_PORT, m_ReadPortBtnCtrl);
	DDX_Control(pDX, IDC_PORT_VALUE, m_PortValueEditCtrl);
	DDX_Control(pDX, IDC_PORT_NUMBER, m_PortNumberEditCtrl);
	DDX_Control(pDX, IDC_READ_PORT2, m_ReadPort2BtnCtrl);
	DDX_Control(pDX, IDC_PORT_VALUE2, m_PortValue2EditCtrl);
	DDX_Control(pDX, IDC_PORT_NUMBER2, m_PortNumber2EditCtrl);
	DDX_Control(pDX, IDC_PORT_VALUE3, m_PortValue2EditCtrl);
	DDX_Control(pDX, IDC_READ_PORT3, m_ReadPort3BtnCtrl);
	DDX_Control(pDX, IDC_PORT_VALUE3, m_PortValue3EditCtrl);
	DDX_Control(pDX, IDC_CLR_BIT, m_ClrBitBtnCtrl);
	DDX_Control(pDX, IDC_SET_BIT, m_SetBitBtnCtrl);
	DDX_Control(pDX, IDC_WRITE_BIT, m_WriteBitBtnCtrl);
	DDX_Control(pDX, IDC_READ_BIT, m_ReadBitBtnCtrl);
	DDX_Control(pDX, IDC_OPEN_DEVICE, m_OpenDeviceBtnCtrl);
	DDX_Control(pDX, IDC_CLOSE_DEVICE, m_CloseDeviceBtnCtrl);
	DDX_Control(pDX, IDC_BIT_VALUE, m_BitValueEditCtrl);
	DDX_Control(pDX, IDC_BIT_NUMBER, m_BitNumberEditCtrl);
	DDX_Control(pDX, IDC_DEVICE, m_DeviceCBCtrl);
	DDX_Text(pDX, IDC_BIT_NUMBER, m_nBitNumber);
	DDX_Text(pDX, IDC_BIT_VALUE, m_nBitValue);
	DDX_Text(pDX, IDC_BITS_24_01, m_strBits24_01);
	DDV_MaxChars(pDX, m_strBits24_01, 24);
	DDX_Text(pDX, IDC_BITS_48_25, m_strBits48_25);
	DDV_MaxChars(pDX, m_strBits48_25, 24);
	DDX_Text(pDX, IDC_BITS_72_49, m_strBits72_49);
	DDV_MaxChars(pDX, m_strBits72_49, 24);
	DDX_Text(pDX, IDC_BITS_96_73, m_strBits96_73);
	DDV_MaxChars(pDX, m_strBits96_73, 24);
	DDX_Text(pDX, IDC_PORT_NUMBER, m_nPortNumber);
	DDX_Text(pDX, IDC_PORT_VALUE, m_byPortValue);
	DDV_MinMaxByte(pDX, m_byPortValue, 0, 255);
	DDX_Text(pDX, IDC_PORT_NUMBER2, m_nPortNumber2);
	DDX_Text(pDX, IDC_PORT_VALUE2, m_strDwPortValue2);
	DDV_MaxChars(pDX, m_strDwPortValue2, 8);
	DDX_Text(pDX, IDC_PORT_VALUE3, m_strDwlPortValue3);
	DDV_MaxChars(pDX, m_strDwlPortValue3, 12);
	DDX_Text(pDX, IDC_ENABLE_24_01, m_strEnable24_01);
	DDV_MaxChars(pDX, m_strEnable24_01, 24);
	DDX_Text(pDX, IDC_ENABLE_48_25, m_strEnable48_25);
	DDV_MaxChars(pDX, m_strEnable48_25, 24);
	DDX_Text(pDX, IDC_MASK_24_01, m_strMask24_01);
	DDV_MaxChars(pDX, m_strMask24_01, 24);
	DDX_Text(pDX, IDC_MASK_48_25, m_strMask48_25);
	DDV_MaxChars(pDX, m_strMask48_25, 24);
	DDX_Text(pDX, IDC_MASK_72_49, m_strMask72_49);
	DDV_MaxChars(pDX, m_strMask72_49, 24);
	DDX_Text(pDX, IDC_MASK_96_73, m_strMask96_73);
	DDV_MaxChars(pDX, m_strMask96_73, 24);
	DDX_Text(pDX, IDC_POLARITY_24_01, m_strPolarity24_01);
	DDV_MaxChars(pDX, m_strPolarity24_01, 24);
	DDX_Text(pDX, IDC_POLARITY_48_25, m_strPolarity48_25);
	DDV_MaxChars(pDX, m_strPolarity48_25, 24);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWSUIO48_96TestXPDlg, CDialog)
	//{{AFX_MSG_MAP(CWSUIO48_96TestXPDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN_DEVICE, OnOpenDevice)
	ON_BN_CLICKED(IDC_CLOSE_DEVICE, OnCloseDevice)
	ON_BN_CLICKED(IDC_READ_BIT, OnReadBit)
	ON_BN_CLICKED(IDC_WRITE_BIT, OnWriteBit)
	ON_BN_CLICKED(IDC_SET_BIT, OnSetBit)
	ON_BN_CLICKED(IDC_CLR_BIT, OnClrBit)
	ON_BN_CLICKED(IDC_READ_PORT, OnReadPort)
	ON_BN_CLICKED(IDC_WRITE_PORT, OnWritePort)
	ON_BN_CLICKED(IDC_READ_PORT2, OnReadPort2)
	ON_BN_CLICKED(IDC_READ_PORT3, OnReadPort3)
	ON_BN_CLICKED(IDC_SET_MASK, OnSetMask)
	ON_BN_CLICKED(IDC_GET_MASK, OnGetMask)
	ON_BN_CLICKED(IDC_CLEAR_MASK, OnClearMask)
	ON_BN_CLICKED(IDC_SET_INTERRUPTS, OnSetInterrupts)
	ON_BN_CLICKED(IDC_CLEAR_INTERRUPTS, OnClearInterrupts)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_WSUIO_SHOW_INTERRUPTS, OnShowInterrupts)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWSUIO48_96TestXPDlg message handlers

BOOL CWSUIO48_96TestXPDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_DeviceCBCtrl.AddString(_T("WSUIO48_96XP_0"));
	m_DeviceCBCtrl.AddString(_T("WSUIO48_96XP_1"));
	m_DeviceCBCtrl.SetCurSel(0);

	// Disable controls not valid.
	DisableDialogControls();

	// Initialize critical section.
	InitializeCriticalSection(&m_ThreadData.hThreadCS);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWSUIO48_96TestXPDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWSUIO48_96TestXPDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CWSUIO48_96TestXPDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CWSUIO48_96TestXPDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	CWSUIO48_96Help		WSUIO48_96HelpDlg;

	// Display help dialog.
	WSUIO48_96HelpDlg.DoModal();

	//return CDialog::OnHelpInfo(pHelpInfo);
	return TRUE;
}

void CWSUIO48_96TestXPDlg::OnOpenDevice() 
{
	CString		strUserDeviceName;
	CString		strDeviceName;

	m_DeviceCBCtrl.GetLBText(m_DeviceCBCtrl.GetCurSel(),
		strUserDeviceName);

	strDeviceName = _T("\\\\.\\") + strUserDeviceName;

	// Note: Make sure that the flag FILE_FLAG_OVERLAPPED is set
	// so that the call to CancelIo() will cancel the pending
	// IOCTL_WIO_WAIT_ON_INT is cancelled in the driver.
	m_ThreadData.hWIOHandle = CreateFile(	strDeviceName,
											GENERIC_READ | GENERIC_WRITE,
											0,
											NULL,
											OPEN_EXISTING,
											FILE_FLAG_OVERLAPPED,
											NULL);
	if (INVALID_HANDLE_VALUE == m_ThreadData.hWIOHandle)
	{
		CString	strErrorMsg;

		strErrorMsg.Format(_T("Unable to open device %s (%d)."),
			strUserDeviceName, GetLastError());
		AfxMessageBox(strErrorMsg, MB_OK);
	}
	else
	{
		DWORD	dwActualOut;

		if (DeviceIoControl(m_ThreadData.hWIOHandle,
							IOCTL_WIO_GET_NUM_IO_POINTS,
							NULL,
							0,
							(PVOID) &m_ThreadData.dwNumIOPoints,
							sizeof(DWORD),
							&dwActualOut,
							NULL))
		{
			// Initialize flags.
			m_ThreadData.fExitThread = FALSE;
			m_ThreadData.fInterruptsSet = FALSE;

			// Check if interrupts are permitted in the driver.
			if (DeviceIoControl(m_ThreadData.hWIOHandle,
								IOCTL_WIO_INT_PERMITTED,
								NULL,
								0,
								&m_dwInterruptsPermitted,
								sizeof(DWORD),
								&dwActualOut,
								NULL))
			{
				if (m_dwInterruptsPermitted)
				{
					// Set the HWND of the dialog window into the thread data.
					m_ThreadData.hwndDialog = m_hWnd;

					// Create an event to trigger the thread to exit.
					m_ThreadData.hExitThread = CreateEvent(0, FALSE, FALSE, NULL);

					// Create an event for the thread to trigger upon exiting.
					m_ThreadData.hThreadExited = CreateEvent(0, FALSE, FALSE, NULL);

					// Create thread to handle event triggers from
					// device driver.
					m_hDeviceThread = CreateThread(	NULL,
													0,
													CWSUIO48_96TestXPDlg::DeviceThread,
													&m_ThreadData,
													0,
													NULL);
					if (NULL == m_hDeviceThread)
					{
						AfxMessageBox(_T("Error creating thread."), MB_OK);
					}
				}
			}

			// Create a timer to update the display with
			// the data received from the thread.
			m_nUpdateTimer = SetTimer(1, 500, 0);

			// Enable controls that are now valid.
			EnableDialogControls();

			// Disable controls that are now invalid.
			m_OpenDeviceBtnCtrl.EnableWindow(FALSE);
			m_DeviceCBCtrl.EnableWindow(FALSE);

			// Update dialog.
			UpdateData(FALSE);
		}
		else
		{
			AfxMessageBox(_T("Unable to get number of I/O points."), MB_OK);
		}
	}
}

void CWSUIO48_96TestXPDlg::OnCloseDevice() 
{
	// Signal the thread to exit.
	m_ThreadData.fExitThread = TRUE;

	// Close the device driver.
	if (INVALID_HANDLE_VALUE != m_ThreadData.hWIOHandle)
	{
		if (INVALID_HANDLE_VALUE != m_hDeviceThread)
		{
			// Signal the thread to exit.
			SetEvent(m_ThreadData.hExitThread);

			// Wait for thread to exit.
			WaitForSingleObject(m_ThreadData.hThreadExited, 3000);
			Sleep(10);

			// Close the thread handle.
			CloseHandle(m_hDeviceThread);
			m_hDeviceThread = INVALID_HANDLE_VALUE;
		}

		// Close the device.
		CloseHandle(m_ThreadData.hWIOHandle);
		m_ThreadData.hWIOHandle = INVALID_HANDLE_VALUE;
	}

	if (INVALID_HANDLE_VALUE == m_ThreadData.hExitThread)
	{
		CloseHandle(m_ThreadData.hExitThread);
		m_ThreadData.hExitThread = INVALID_HANDLE_VALUE;
	}

	if (INVALID_HANDLE_VALUE == m_ThreadData.hThreadExited)
	{
		CloseHandle(m_ThreadData.hThreadExited);
		m_ThreadData.hThreadExited = INVALID_HANDLE_VALUE;
	}

	for (int nDevice = 0; nDevice < MAX_DEVICES; ++nDevice)
	{
		for (int nPort = 0; nPort < MAX_IO_PORTS; ++nPort)
		{
			m_byPortImage[nDevice][nPort] = 0;
		}

		for (int nPort = 0; nPort < MAX_INT_PORTS; ++nPort)
		{
			m_byIntMask[nDevice][nPort] = 0;
		}
	}

	m_strBits24_01 = _T("000000000000000000000000");
	m_strBits48_25 = _T("000000000000000000000000");
	m_strBits72_49 = _T("000000000000000000000000");
	m_strBits96_73 = _T("000000000000000000000000");

	m_strMask24_01 = _T("000000000000000000000000");
	m_strMask48_25 = _T("000000000000000000000000");
	m_strMask72_49 = _T("000000000000000000000000");
	m_strMask96_73 = _T("000000000000000000000000");

	m_strEnable24_01 = _T("000000000000000000000000");
	m_strEnable48_25 = _T("000000000000000000000000");
	m_strPolarity24_01 = _T("000000000000000000000000");
	m_strPolarity48_25 = _T("000000000000000000000000");

	m_nBitNumber = 1;
	//m_nPortNumber = 1;
	m_nBitValue = 0;
	m_nPortNumber = 1;
	m_byPortValue = 0;
	m_nPortNumber2 = 1;
	m_strDwPortValue2= _T("00000000");
	m_strDwlPortValue3= _T("000000000000");

	// Update the dialog with the new data.
	UpdateData(FALSE);

	// Disable controls that are now valid.
	DisableDialogControls();

	// Enable controls that are now invalid.
	m_OpenDeviceBtnCtrl.EnableWindow(TRUE);
	m_DeviceCBCtrl.EnableWindow(TRUE);
}

void CWSUIO48_96TestXPDlg::OnReadBit() 
{
	BYTE	byBitValue = 0xFF;
	DWORD	dwBitNumber;
	DWORD	dwActualOut;

	// Get the data from the dialog into our variables.
	UpdateData(TRUE);

	dwBitNumber = static_cast<DWORD>(m_nBitNumber);

	// Read bit.
	if (DeviceIoControl(m_ThreadData.hWIOHandle,
						IOCTL_WIO_READ_BIT,
						&dwBitNumber,
						sizeof(DWORD),
						&byBitValue,
						sizeof(BYTE),
						&dwActualOut,
						NULL))
	{
		UpdateBitImageValue(dwBitNumber, byBitValue);
	}
	else
	{
		AfxMessageBox(_T("Error reading bit."), MB_OK);
	}
}

void CWSUIO48_96TestXPDlg::OnWriteBit() 
{
	UIO_WRITE_VALUE		UIOWriteValue;
	DWORD				dwActualOut;

	// Get the data from the dialog into our variables.
	UpdateData(TRUE);

	UIOWriteValue.dwBitNumber = static_cast<DWORD>(m_nBitNumber);
	UIOWriteValue.byValue = static_cast<BYTE>(m_nBitValue);

	// Write bit.
	if (DeviceIoControl(m_ThreadData.hWIOHandle,
						IOCTL_WIO_WRITE_BIT,
						&UIOWriteValue,
						sizeof(UIO_WRITE_VALUE),
						NULL,
						0,
						&dwActualOut,
						NULL))
	{
		UpdateBitImageValue(UIOWriteValue.dwBitNumber, UIOWriteValue.byValue);
	}
	else
	{
		AfxMessageBox(_T("Error writing bit."), MB_OK);
	}
}

void CWSUIO48_96TestXPDlg::OnSetBit() 
{
	DWORD	dwBitNumber;
	DWORD	dwActualOut;

	// Get the data from the dialog into our variables.
	UpdateData(TRUE);

	dwBitNumber = static_cast<DWORD>(m_nBitNumber);
	m_nBitValue = 1;

	// Write bit.
	if (DeviceIoControl(m_ThreadData.hWIOHandle,
						IOCTL_WIO_SET_BIT,
						&dwBitNumber,
						sizeof(DWORD),
						NULL,
						0,
						&dwActualOut,
						NULL))
	{
		UpdateBitImageValue(dwBitNumber, m_nBitValue);
	}
	else
	{
		AfxMessageBox(_T("Error setting bit."), MB_OK);
	}
}

void CWSUIO48_96TestXPDlg::OnClrBit() 
{
	DWORD	dwBitNumber;
	DWORD	dwActualOut;

	// Get the data from the dialog into our variables.
	UpdateData(TRUE);

	dwBitNumber = static_cast<DWORD>(m_nBitNumber);
	m_nBitValue = 0;

	// Write bit.
	if (DeviceIoControl(m_ThreadData.hWIOHandle,
						IOCTL_WIO_CLR_BIT,
						&dwBitNumber,
						sizeof(DWORD),
						NULL,
						0,
						&dwActualOut,
						NULL))
	{
		UpdateBitImageValue(dwBitNumber, m_nBitValue);
	}
	else
	{
		AfxMessageBox(_T("Error clearing bit."), MB_OK);
	}
}

void CWSUIO48_96TestXPDlg::OnReadPort() 
{
	BYTE	byPortValue = 0xFF;
	DWORD	dwPortNumber;
	DWORD	dwActualOut;

	// Get the data from the dialog into our variables.
	UpdateData(TRUE);

	dwPortNumber = static_cast<DWORD>(m_nPortNumber);

	// Read port value.
	if (DeviceIoControl(m_ThreadData.hWIOHandle,
						IOCTL_WIO_READ_BYTE,
						&dwPortNumber,
						sizeof(DWORD),
						&byPortValue,
						sizeof(BYTE),
						&dwActualOut,
						NULL))
	{
		UpdateByteImageValue(dwPortNumber, byPortValue);
	}
	else
	{
		AfxMessageBox(_T("Error reading byte."), MB_OK);
	}
}

void CWSUIO48_96TestXPDlg::OnWritePort() 
{
	UIO_WRITE_VALUE		UIOWriteValue;
	DWORD				dwActualOut;

	// Get the data from the dialog into our variables.
	UpdateData(TRUE);

	UIOWriteValue.dwPortNumber = static_cast<DWORD>(m_nPortNumber);
	UIOWriteValue.byValue = m_byPortValue;

	// Write port value.
	if (DeviceIoControl(m_ThreadData.hWIOHandle,
						IOCTL_WIO_WRITE_BYTE,
						&UIOWriteValue,
						sizeof(UIO_WRITE_VALUE),
						NULL,
						0,
						&dwActualOut,
						NULL))
	{
		UpdateByteImageValue(UIOWriteValue.dwPortNumber,
			UIOWriteValue.byValue);
	}
	else
	{
		AfxMessageBox(_T("Error writing byte."), MB_OK);
	}
}

void CWSUIO48_96TestXPDlg::OnReadPort2() 
{
	DWORD	dwPortValue2 = 0xFFFFFFFF;
	DWORD	dwPortNumber2;
	DWORD	dwActualOut;
	TCHAR	szHexValue[10];

	// Get the data from the dialog into our variables.
	UpdateData(TRUE);

	dwPortNumber2 = static_cast<DWORD>(m_nPortNumber2);

	// Read port value.
	if (DeviceIoControl(m_ThreadData.hWIOHandle,
						IOCTL_WIO_READ_DWORD,
						&dwPortNumber2,
						sizeof(DWORD),
						&dwPortValue2,
						sizeof(DWORD),
						&dwActualOut,
						NULL))
	{
		m_strDwPortValue2.Empty();
		m_strDwPortValue2 += ConvertToHex(dwPortValue2, szHexValue);

		// Update the dialog with the new data.
		UpdateData(FALSE);
	}
	else
	{
		AfxMessageBox(_T("Error reading byte."), MB_OK);
	}
}

void CWSUIO48_96TestXPDlg::OnReadPort3() 
{
	DWORDLONG	dwlPortValue3 = 0xFFFFFFFFFFFF;
	DWORD	dwActualOut;
	TCHAR	szHexValue[14];

	// Get the data from the dialog into our variables.
	UpdateData(TRUE);

	// Read port value.
	if (DeviceIoControl(m_ThreadData.hWIOHandle,
						IOCTL_WIO_READ_ALL_PORTS,
						NULL,
						0,
						&dwlPortValue3,
						sizeof(DWORDLONG),
						&dwActualOut,
						NULL))
	{
		m_strDwlPortValue3.Empty();
		m_strDwlPortValue3 += ConvertToHex2(dwlPortValue3, szHexValue);

		// Update the dialog with the new data.
		UpdateData(FALSE);
	}
	else
	{
		AfxMessageBox(_T("Error reading byte."), MB_OK);
	}
}

void CWSUIO48_96TestXPDlg::OnSetMask() 
{
	BYTE		byIOMask[12];
	DWORD		dwActualOut;
	CString		strIOMask;

	// Get the data from the dialog into our variables.
	UpdateData(TRUE);

	// In the edit field on the dialog the bit string
	// is formated with bit 23 being the first byte in
	// the string and bit 0 being the last byte in the
	// string.

	m_Mask24_01EditCtrl.GetWindowText(strIOMask);
	byIOMask[0] = ConvertFromBinary(strIOMask.Mid(16, 8));
	byIOMask[1] = ConvertFromBinary(strIOMask.Mid(8, 8));
	byIOMask[2] = ConvertFromBinary(strIOMask.Mid(0, 8));

	m_Mask48_25EditCtrl.GetWindowText(strIOMask);
	byIOMask[3] = ConvertFromBinary(strIOMask.Mid(16, 8));
	byIOMask[4] = ConvertFromBinary(strIOMask.Mid(8, 8));
	byIOMask[5] = ConvertFromBinary(strIOMask.Mid(0, 8));

	if (WIO_96_IO_POINTS == m_ThreadData.dwNumIOPoints)
	{
		m_Mask72_49EditCtrl.GetWindowText(strIOMask);
		byIOMask[6] = ConvertFromBinary(strIOMask.Mid(0, 8));
		byIOMask[7] = ConvertFromBinary(strIOMask.Mid(8, 8));
		byIOMask[8] = ConvertFromBinary(strIOMask.Mid(16, 8));

		m_Mask96_73EditCtrl.GetWindowText(strIOMask);
		byIOMask[9] = ConvertFromBinary(strIOMask.Mid(16, 8));
		byIOMask[10] = ConvertFromBinary(strIOMask.Mid(8, 8));
		byIOMask[11] = ConvertFromBinary(strIOMask.Mid(0, 8));
	}

	// Set the mask.
	if (0 == DeviceIoControl(	m_ThreadData.hWIOHandle,
								IOCTL_WIO_SET_IO_MASK,
								&byIOMask,
								(m_ThreadData.dwNumIOPoints / MAX_BITS_BYTE),
								NULL,
								0,
								&dwActualOut,
								NULL))
	{
		AfxMessageBox(_T("Error setting mask."), MB_OK);
	}
}

void CWSUIO48_96TestXPDlg::OnGetMask() 
{
	BYTE	byIOMask[12];
	DWORD	dwActualOut;
	TCHAR	szBinaryValue[10];

	// Get the mask.
	if (DeviceIoControl(m_ThreadData.hWIOHandle,
						IOCTL_WIO_GET_IO_MASK,
						NULL,
						0,
						&byIOMask,
						(m_ThreadData.dwNumIOPoints / MAX_BITS_BYTE),
						&dwActualOut,
						NULL))
	{
		// In the edit field on the dialog the bit string
		// is formated with bit 23 being the first byte in
		// the string and bit 0 being the last byte in the
		// string.

		m_strMask24_01.Empty();
		m_strMask24_01 += ConvertToBinary(byIOMask[2], szBinaryValue);
		m_strMask24_01 += ConvertToBinary(byIOMask[1], szBinaryValue);
		m_strMask24_01 += ConvertToBinary(byIOMask[0], szBinaryValue);

		m_strMask48_25.Empty();
		m_strMask48_25 += ConvertToBinary(byIOMask[5], szBinaryValue);
		m_strMask48_25 += ConvertToBinary(byIOMask[4], szBinaryValue);
		m_strMask48_25 += ConvertToBinary(byIOMask[3], szBinaryValue);

		if (WIO_96_IO_POINTS == m_ThreadData.dwNumIOPoints)
		{
			m_strMask72_49.Empty();
			m_strMask72_49 += ConvertToBinary(byIOMask[8], szBinaryValue);
			m_strMask72_49 += ConvertToBinary(byIOMask[7], szBinaryValue);
			m_strMask72_49 += ConvertToBinary(byIOMask[6], szBinaryValue);

			m_strMask96_73.Empty();
			m_strMask96_73 += ConvertToBinary(byIOMask[11], szBinaryValue);
			m_strMask96_73 += ConvertToBinary(byIOMask[10], szBinaryValue);
			m_strMask96_73 += ConvertToBinary(byIOMask[9], szBinaryValue);
		}

		// Update the dialog with the new data.
		UpdateData(FALSE);
	}
	else
	{
		AfxMessageBox(_T("Error getting mask."), MB_OK);
	}
}

void CWSUIO48_96TestXPDlg::OnClearMask() 
{
	DWORD	dwActualOut;

	// Clear the mask.
	if (DeviceIoControl(m_ThreadData.hWIOHandle,
						IOCTL_WIO_CLEAR_IO_MASK,
						NULL,
						0,
						NULL,
						0,
						&dwActualOut,
						NULL))
	{
		m_strMask24_01 = _T("000000000000000000000000");
		m_strMask48_25 = _T("000000000000000000000000");
		m_strMask72_49 = _T("000000000000000000000000");
		m_strMask96_73 = _T("000000000000000000000000");

		// Update the dialog with the new data.
		UpdateData(FALSE);
	}
	else
	{
		AfxMessageBox(_T("Error clearing mask."), MB_OK);
	}
}

void CWSUIO48_96TestXPDlg::OnSetInterrupts() 
{
	UIO_CONFIG_INTERRUPT	UIOConfigInterrupt;
	BYTE					byEnableMask[MAX_DEVICES][MAX_INT_PORTS];
	BYTE					byPolarityMask[MAX_DEVICES][MAX_INT_PORTS];
	BYTE					byNewDisable;
	BYTE					byNewEnable;
	BYTE					byNewPolarity;
	BYTE					byBitMask;
	DWORD					dwBitNumber;
	DWORD					dwActualOut;
	CString					strEnableMask;
	CString					strPolarityMask;

	// Get the data from the dialog into our variables.
	UpdateData(TRUE);

	// In the edit field on the dialog the bit string
	// is formated with bit 23 being the first byte in
	// the string and bit 0 being the last byte in the
	// string.

	strEnableMask = m_strEnable24_01;
	byEnableMask[0][0] = ConvertFromBinary(strEnableMask.Mid(16, 8));
	byEnableMask[0][1] = ConvertFromBinary(strEnableMask.Mid(8, 8));
	byEnableMask[0][2] = ConvertFromBinary(strEnableMask.Mid(0, 8));

	strPolarityMask = m_strPolarity24_01;
	byPolarityMask[0][0] = ConvertFromBinary(strPolarityMask.Mid(16, 8));
	byPolarityMask[0][1] = ConvertFromBinary(strPolarityMask.Mid(8, 8));
	byPolarityMask[0][2] = ConvertFromBinary(strPolarityMask.Mid(0, 8));

	if (WIO_96_IO_POINTS == m_ThreadData.dwNumIOPoints)
	{
		strEnableMask = m_strEnable48_25;
		byEnableMask[1][0] = ConvertFromBinary(strEnableMask.Mid(16, 8));
		byEnableMask[1][1] = ConvertFromBinary(strEnableMask.Mid(8, 8));
		byEnableMask[1][2] = ConvertFromBinary(strEnableMask.Mid(0, 8));

		strPolarityMask = m_strPolarity48_25;
		byPolarityMask[1][0] = ConvertFromBinary(strPolarityMask.Mid(16, 8));
		byPolarityMask[1][1] = ConvertFromBinary(strPolarityMask.Mid(8, 8));
		byPolarityMask[1][2] = ConvertFromBinary(strPolarityMask.Mid(0, 8));
	}

	// Disable any of the interrupts that have been turned off.
	dwBitNumber = 1;
	for (	int nDevice = 0;
			nDevice < static_cast<int>(m_ThreadData.dwNumIOPoints / MAX_IO_POINTS);
			++nDevice)
	{
		for (int nPort = 0; nPort < MAX_INT_PORTS; ++nPort)
		{
			byNewDisable =
				m_byIntMask[nDevice][nPort] & ~byEnableMask[nDevice][nPort];

			byBitMask = 1;
			for (int nBit = 0; nBit < MAX_BITS_BYTE; ++nBit)
			{
				if (byNewDisable & byBitMask)
				{
					if (DeviceIoControl(m_ThreadData.hWIOHandle,
										IOCTL_WIO_DISAB_INT,
										&dwBitNumber,
										sizeof(DWORD),
										NULL,
										0,
										&dwActualOut,
										NULL))
					{
						m_byIntMask[nDevice][nPort] &= ~byBitMask;
					}
					else
					{
						AfxMessageBox(_T("Error disabling interrupt."), MB_OK);
					}
				}

				byNewDisable &= ~byBitMask;
				byBitMask = byBitMask << 1;
				++dwBitNumber;
			}
		}
	}

	// Enable any of the interrupts that have been turned on.
	// Disable any of the interrupts that have been turned off.
	dwBitNumber = 1;
	for (int nDevice = 0;
			nDevice < static_cast<int>(m_ThreadData.dwNumIOPoints / MAX_IO_POINTS);
			++nDevice)
	{
		for (int nPort = 0; nPort < MAX_INT_PORTS; ++nPort)
		{
			byNewEnable =
				m_byIntMask[nDevice][nPort] ^ byEnableMask[nDevice][nPort];
			byNewPolarity = byPolarityMask[nDevice][nPort];

			byBitMask = 1;
			for (int nBit = 0; nBit < MAX_BITS_BYTE; ++nBit)
			{
				if (byNewEnable & byBitMask)
				{
					UIOConfigInterrupt.dwBitNumber = dwBitNumber;
					UIOConfigInterrupt.byPolarity = 
						(byNewPolarity & byBitMask) ? 1 : 0;

					if (DeviceIoControl(m_ThreadData.hWIOHandle,
										IOCTL_WIO_ENAB_INT,
										&UIOConfigInterrupt,
										sizeof(UIO_CONFIG_INTERRUPT),
										NULL,
										0,
										&dwActualOut,
										NULL))
					{
						m_byIntMask[nDevice][nPort] |= byBitMask;

						// An interrupt has been requested for an I/O point,
						// set flag.
						m_ThreadData.fInterruptsSet = TRUE;
					}
					else
					{
						AfxMessageBox(_T("Error enabling interrupt."), MB_OK);
					}
				}

				byNewEnable &= ~byBitMask;
				byBitMask = byBitMask << 1;
				++dwBitNumber;
			}
		}
	}
}

void CWSUIO48_96TestXPDlg::OnClearInterrupts() 
{
	BYTE		byNewDisable;
	BYTE		byBitMask;
	DWORD		dwBitNumber;
	DWORD		dwActualOut;
	TCHAR		szBinaryValue[10];
	CString		strFieldValue;

	dwBitNumber = 1;
	for (	int nDevice = 0;
			nDevice < static_cast<int>(m_ThreadData.dwNumIOPoints / MAX_IO_POINTS);
			++nDevice)
	{
		for (int nPort = 0; nPort < MAX_INT_PORTS; ++nPort)
		{
			byNewDisable = m_byIntMask[nDevice][nPort] & 0xFF;

			byBitMask = 1;
			for (int nBit = 0; nBit < 8; ++nBit)
			{
				if (byNewDisable & byBitMask)
				{
					if (DeviceIoControl(m_ThreadData.hWIOHandle,
										IOCTL_WIO_DISAB_INT,
										&dwBitNumber,
										sizeof(DWORD),
										NULL,
										0,
										&dwActualOut,
										NULL))
					{
						m_byIntMask[nDevice][nPort] &= ~byBitMask;
					}
					else
					{
						AfxMessageBox(_T("Error disabling interrupt."), MB_OK);
					}
				}

				byNewDisable &= ~byBitMask;
				byBitMask = byBitMask << 1;
				++dwBitNumber;
			}

		}
	}

	// No interrupts are set, clear flag.
	m_ThreadData.fInterruptsSet = FALSE;

	// Update the dialog.
	strFieldValue.Empty();
	strFieldValue += ConvertToBinary(m_byIntMask[0][2], szBinaryValue);
	strFieldValue += ConvertToBinary(m_byIntMask[0][1], szBinaryValue);
	strFieldValue += ConvertToBinary(m_byIntMask[0][0], szBinaryValue);
	m_strEnable24_01 = strFieldValue;

	strFieldValue.Empty();
	strFieldValue += ConvertToBinary(0, szBinaryValue);
	strFieldValue += ConvertToBinary(0, szBinaryValue);
	strFieldValue += ConvertToBinary(0, szBinaryValue);
	m_strPolarity24_01 = strFieldValue;

	if (WIO_96_IO_POINTS == m_ThreadData.dwNumIOPoints)
	{
		strFieldValue.Empty();
		strFieldValue += ConvertToBinary(m_byIntMask[1][2], szBinaryValue);
		strFieldValue += ConvertToBinary(m_byIntMask[1][1], szBinaryValue);
		strFieldValue += ConvertToBinary(m_byIntMask[1][0], szBinaryValue);
		m_strEnable48_25 = strFieldValue;

		strFieldValue.Empty();
		strFieldValue += ConvertToBinary(0, szBinaryValue);
		strFieldValue += ConvertToBinary(0, szBinaryValue);
		strFieldValue += ConvertToBinary(0, szBinaryValue);
		m_strPolarity48_25 = strFieldValue;
	}

	// Update the dialog with the new data.
	UpdateData(FALSE);
}

void CWSUIO48_96TestXPDlg::OnTimer(UINT nIDEvent) 
{
	BYTE		byPortValue = 0xFF;
	DWORD		dwPortNumber;
	DWORD		dwActualOut;
	TCHAR		szBinaryValue[10];

	// Read new values from device.
	for (	int nDevice = 0;
			nDevice < static_cast<int>(m_ThreadData.dwNumIOPoints / MAX_IO_POINTS);
			++nDevice)
	{
		for (int nPort = 0; nPort < MAX_IO_PORTS; ++nPort)
		{
			dwPortNumber = (nDevice * MAX_IO_PORTS) + nPort + 1;

			if (DeviceIoControl(m_ThreadData.hWIOHandle,
								IOCTL_WIO_READ_BYTE,
								&dwPortNumber,
								sizeof(DWORD),
								&byPortValue,
								sizeof(BYTE),
								&dwActualOut,
								NULL))
			{
				m_byPortImage[nDevice][nPort] = byPortValue;
			}
			else
			{
				m_byPortImage[nDevice][nPort] = 0;
			}
		}
	}

	// Update the display with the new values.
	m_strBits24_01.Empty();
	m_strBits24_01 += ConvertToBinary(m_byPortImage[0][2], szBinaryValue);
	m_strBits24_01 += ConvertToBinary(m_byPortImage[0][1], szBinaryValue);
	m_strBits24_01 += ConvertToBinary(m_byPortImage[0][0], szBinaryValue);
	m_Bits24_01EditCtrl.SetWindowText(m_strBits24_01);

	m_strBits48_25.Empty();
	m_strBits48_25 += ConvertToBinary(m_byPortImage[0][5], szBinaryValue);
	m_strBits48_25 += ConvertToBinary(m_byPortImage[0][4], szBinaryValue);
	m_strBits48_25 += ConvertToBinary(m_byPortImage[0][3], szBinaryValue);
	m_Bits48_25EditCtrl.SetWindowText(m_strBits48_25);

	if (WIO_96_IO_POINTS == m_ThreadData.dwNumIOPoints)
	{
		m_strBits72_49.Empty();
		m_strBits72_49 += ConvertToBinary(m_byPortImage[1][2], szBinaryValue);
		m_strBits72_49 += ConvertToBinary(m_byPortImage[1][1], szBinaryValue);
		m_strBits72_49 += ConvertToBinary(m_byPortImage[1][0], szBinaryValue);
		m_Bits72_49EditCtrl.SetWindowText(m_strBits72_49);

		m_strBits96_73.Empty();
		m_strBits96_73 += ConvertToBinary(m_byPortImage[1][5], szBinaryValue);
		m_strBits96_73 += ConvertToBinary(m_byPortImage[1][4], szBinaryValue);
		m_strBits96_73 += ConvertToBinary(m_byPortImage[1][3], szBinaryValue);
		m_Bits96_73EditCtrl.SetWindowText(m_strBits96_73);
	}
	
	CDialog::OnTimer(nIDEvent);
}

LRESULT CWSUIO48_96TestXPDlg::OnShowInterrupts(WPARAM wParam, LPARAM lParam)
{
	CString		strInterrupts;

	// Update the display with an astrisk '*' in the position
	// where an interrupt occurred.
	// The WM_TIMER event will then update the field with
	// the data.
	m_Bits24_01EditCtrl.GetWindowText(strInterrupts);
	EnterCriticalSection(&(m_ThreadData.hThreadCS));
	for (int nStrByte = 23, nPort = 0; nPort < MAX_INT_PORTS; ++nPort)
	{
		BYTE	byBitMask = 1;

		for (int nBit = 0; nBit < MAX_BITS_BYTE; ++nBit)
		{
			if (m_ThreadData.byIntImage[0][nPort] & byBitMask)
			{
				strInterrupts.SetAt(nStrByte, _T('*'));
			}

			--nStrByte;
			byBitMask = byBitMask << 1;
		}
	}
	LeaveCriticalSection(&(m_ThreadData.hThreadCS));
	m_Bits24_01EditCtrl.SetWindowText(strInterrupts);

	if (WIO_96_IO_POINTS == m_ThreadData.dwNumIOPoints)
	{
		m_Bits72_49EditCtrl.GetWindowText(strInterrupts);
		EnterCriticalSection(&(m_ThreadData.hThreadCS));
		for (int nStrByte = 23, nPort = 0; nPort < MAX_INT_PORTS; ++nPort)
		{
			BYTE	byBitMask = 1;

			for (int nBit = 0; nBit < MAX_BITS_BYTE; ++nBit)
			{
				if (m_ThreadData.byIntImage[1][nPort] & byBitMask)
				{
					strInterrupts.SetAt(nStrByte, _T('*'));
				}

				--nStrByte;
				byBitMask = byBitMask << 1;
			}
		}
		LeaveCriticalSection(&(m_ThreadData.hThreadCS));
		m_Bits72_49EditCtrl.SetWindowText(strInterrupts);
	}

	return 0;
}

void CWSUIO48_96TestXPDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// Kill the thread to update the display.
	if (0 != m_nUpdateTimer)
	{
		KillTimer(m_nUpdateTimer);
		m_nUpdateTimer = 0;
	}

	// Signal the thread to exit.
	m_ThreadData.fExitThread = TRUE;

	// Close the device driver.
	if (INVALID_HANDLE_VALUE != m_ThreadData.hWIOHandle)
	{
		CloseHandle(m_ThreadData.hWIOHandle);
		m_ThreadData.hWIOHandle = INVALID_HANDLE_VALUE;
	}

	// Now close the thread.
	// Note: The reason we did not close the thread prior to closing
	// the device driver is that if there are I/O points configured
	// for interrupts, the thread will be waiting on the call to
	// DeviceIoControl to return, since it is waiting on an interrupt.
	// The closing of the device driver will force a return of the
	// call to DeviceIoControl, at which point it will not call
	// DeviceIoControl again, because the flag m_fExitThread is set
	// to TRUE.
	if (INVALID_HANDLE_VALUE != m_hDeviceThread)
	{
		// Wait for thread to exit.
		WaitForSingleObject(m_ThreadData.hThreadExited, 3000);
		Sleep(10);

		CloseHandle(m_hDeviceThread);
		m_hDeviceThread = INVALID_HANDLE_VALUE;
	}

	if (INVALID_HANDLE_VALUE == m_ThreadData.hThreadExited)
	{
		CloseHandle(m_ThreadData.hThreadExited);
		m_ThreadData.hThreadExited = INVALID_HANDLE_VALUE;
	}

	DeleteCriticalSection(&m_ThreadData.hThreadCS);
}
