// WSUIO48_96TestXPDlg.h : header file
//

#if !defined(AFX_WSUIO48_96TESTXPDLG_H__5B43A9E9_F111_424F_9FE6_779A98A64D1E__INCLUDED_)
#define AFX_WSUIO48_96TESTXPDLG_H__5B43A9E9_F111_424F_9FE6_779A98A64D1E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <winioctl.h>
#include "Ioctls.h"

typedef struct _ThreadData
{
	// Image of which bits have triggered an interrupt.
	BYTE	byIntImage[MAX_DEVICES][MAX_INT_PORTS];

	// Flag to indicate the thread should exit.
	BOOL	fExitThread;

	// Handle to UIO device.
	HANDLE	hWIOHandle;

	// Number of I/O points in the device.
	DWORD	dwNumIOPoints;

	// Handle to event to signal thread to exit.
	HANDLE	hExitThread;

	// Handle to event to signal thread exited.
	HANDLE	hThreadExited;

	// Flag to indicate that interrupts have been enabled for an I/O point.
	BOOL	fInterruptsSet;

	// Handle of dialog window.
	HWND	hwndDialog;

	// Critical section to govern data access to the thread data.
	CRITICAL_SECTION	hThreadCS;

} THREAD_DATA, *PTHREAD_DATA;

/////////////////////////////////////////////////////////////////////////////
// CWSUIO48_96TestXPDlg dialog

class CWSUIO48_96TestXPDlg : public CDialog
{
	// Flag to indicate if interrupts are permitted in the driver.
	DWORD			m_dwInterruptsPermitted;

	// Current I/O image.
	BYTE			m_byPortImage[MAX_DEVICES][MAX_IO_PORTS];

	// Interrupt mask in the device.
	BYTE			m_byIntMask[MAX_DEVICES][MAX_INT_PORTS];

	// Handle to thread to handle events from the driver.
	HANDLE			m_hDeviceThread;

	// Data to share with the thread to handle events from the driver.
	THREAD_DATA		m_ThreadData;

	// Timer identifier.
	UINT			m_nUpdateTimer;

// Construction
public:
	CWSUIO48_96TestXPDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CWSUIO48_96TestXPDlg)
	enum { IDD = IDD_WSUIO48_96TESTXP_DIALOG };
	CButton	m_SetMaskBtnCtrl;
	CButton	m_SetInterruptsBtnCtrl;
	CEdit	m_Polarity48_25EditCtrl;
	CEdit	m_Polarity24_01EditCtrl;
	CEdit	m_Mask96_73EditCtrl;
	CEdit	m_Mask72_49EditCtrl;
	CEdit	m_Mask48_25EditCtrl;
	CEdit	m_Mask24_01EditCtrl;
	CButton	m_GetMaskBtnCtrl;
	CEdit	m_Enable48_25EditCtrl;
	CEdit	m_Enable24_01EditCtrl;
	CButton	m_ClearMaskBtnCtrl;
	CButton	m_ClearInterruptsBtnCtrl;
	CEdit	m_Bits96_73EditCtrl;
	CEdit	m_Bits72_49EditCtrl;
	CEdit	m_Bits48_25EditCtrl;
	CEdit	m_Bits24_01EditCtrl;
	CButton	m_WritePortBtnCtrl;
	CButton	m_ReadPortBtnCtrl;
	CEdit	m_PortValueEditCtrl;
	CEdit	m_PortNumberEditCtrl;
	CButton	m_ReadPort2BtnCtrl;
	CEdit	m_PortValue2EditCtrl;
	CEdit	m_PortNumber2EditCtrl;
	CButton	m_ReadPort3BtnCtrl;
	CEdit	m_PortValue3EditCtrl;
	CButton	m_ClrBitBtnCtrl;
	CButton	m_SetBitBtnCtrl;
	CButton	m_WriteBitBtnCtrl;
	CButton	m_ReadBitBtnCtrl;
	CButton	m_OpenDeviceBtnCtrl;
	CButton	m_CloseDeviceBtnCtrl;
	CEdit	m_BitValueEditCtrl;
	CEdit	m_BitNumberEditCtrl;
	CComboBox	m_DeviceCBCtrl;
	int		m_nBitNumber;
	BOOL	m_nBitValue;
	CString	m_strBits24_01;
	CString	m_strBits48_25;
	CString	m_strBits72_49;
	CString	m_strBits96_73;
	int		m_nPortNumber;
	BYTE	m_byPortValue;
	int		m_nPortNumber2;
	CString	m_strDwPortValue2;
	CString	m_strDwlPortValue3;
	CString	m_strEnable24_01;
	CString	m_strEnable48_25;
	CString	m_strMask24_01;
	CString	m_strMask48_25;
	CString	m_strMask72_49;
	CString	m_strMask96_73;
	CString	m_strPolarity24_01;
	CString	m_strPolarity48_25;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CWSUIO48_96TestXPDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	void EnableDialogControls();
	void DisableDialogControls();

	void UpdateBitImageValue(DWORD dwBitNumber, BYTE byBitValue);
	void UpdateByteImageValue(DWORD dwPortNumber, BYTE byPortValue);
	void UpdateIODisplay();

	const BYTE ConvertFromBinary(LPCTSTR pszAnsiBinary);
	const PTCHAR ConvertToBinary(BYTE byValue, PTCHAR pszAnsiBinary);
	const PTCHAR ConvertToHex(DWORD dwValue, PTCHAR pszAnsiHex);
	const PTCHAR ConvertToHex2(DWORDLONG dwlValue, PTCHAR pszAnsiHex);

	static DWORD WINAPI DeviceThread(PVOID pContext);

	// Generated message map functions
	//{{AFX_MSG(CWSUIO48_96TestXPDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnOpenDevice();
	afx_msg void OnCloseDevice();
	afx_msg void OnReadBit();
	afx_msg void OnWriteBit();
	afx_msg void OnSetBit();
	afx_msg void OnClrBit();
	afx_msg void OnReadPort();
	afx_msg void OnWritePort();
	afx_msg void OnReadPort2();
	afx_msg void OnReadPort3();
	afx_msg void OnSetMask();
	afx_msg void OnGetMask();
	afx_msg void OnClearMask();
	afx_msg void OnSetInterrupts();
	afx_msg void OnClearInterrupts();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDestroy();
	afx_msg BOOL OnHelpInfo(HELPINFO* pHelpInfo);
	//}}AFX_MSG
	afx_msg LRESULT OnShowInterrupts(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WSUIO48_96TESTXPDLG_H__5B43A9E9_F111_424F_9FE6_779A98A64D1E__INCLUDED_)
